package com.lo53_mobile_localization.core.service;

import com.lo53_mobile_localization.core.entity.AccessPoint;
import com.lo53_mobile_localization.core.entity.IEntity;
import com.lo53_mobile_localization.core.repository.AccessPointDAO;
import com.lo53_mobile_localization.core.util.HibernateUtil;
import org.hibernate.Session;
import org.hibernate.query.Query;

import java.util.List;

/**
 * Created by Thomas on 10/05/2017.
 */
public class AccessPointService implements IService{


    protected AccessPointDAO accessPointDAO;

    public AccessPointService(){
        this.accessPointDAO = new AccessPointDAO();
    }

    public void storeEntity(IEntity entity) {
        this.accessPointDAO.insertEntity((AccessPoint) entity);
    }

    public void updateEntity(int id, IEntity entity) throws Exception {
        this.accessPointDAO.updateEntity(id, (AccessPoint) entity);
    }

    public void removeEntity(int id) throws Exception {
        this.accessPointDAO.removeEntity(id);
    }

    public IEntity getEntity(int id) throws Exception {
        return this.accessPointDAO.getEntity(id);
    }

    public List getEntities() throws Exception {
        return this.accessPointDAO.getEntities();
    }

    public AccessPoint getSingleAccessPointFromMacAdress(String mac){

        Session session = HibernateUtil.getSession();
        session.beginTransaction();

        String hql= "from " + AccessPoint.class.getCanonicalName() + " ap where ap.mac_address = :mac";

        Query query = session.createQuery(hql);
        query.setParameter("mac", mac);

        AccessPoint result = (AccessPoint) query.getSingleResult();

        return result;
    }

    public List<AccessPoint> getAccessPointFromMacAdress(String mac){

        Session session = HibernateUtil.getSession();
        session.beginTransaction();

        String hql= "from " + AccessPoint.class.getCanonicalName() + " ap where ap.mac_address = :mac";

        Query query = session.createQuery(hql);
        query.setParameter("mac", mac);

        List<AccessPoint> result = query.list();

        return result;
    }

}
