package com.lo53_mobile_localization.core.service;

import com.lo53_mobile_localization.core.entity.*;
import com.lo53_mobile_localization.core.repository.RSSIDAO;
import com.lo53_mobile_localization.core.util.HibernateUtil;
import org.hibernate.Session;
import org.hibernate.query.Query;

import java.util.List;

/**
 * Created by Thomas on 10/05/2017.
 */
public class RSSIService {


    protected RSSIDAO rssi_recordDAO;

    public RSSIService(){
        this.rssi_recordDAO = new RSSIDAO();
    }

    public void storeEntity(IEntity entity) {
        this.rssi_recordDAO.insertEntity((Rssi) entity);
    }

    public void updateEntity(int id, IEntity entity) throws Exception {
        this.rssi_recordDAO.updateEntity(id, (Rssi) entity);
    }

    public void removeEntity(int id) throws Exception {
        this.rssi_recordDAO.removeEntity(id);
    }

    public Rssi getEntity(int id) throws Exception {
        return this.rssi_recordDAO.getEntity(id);
    }

    public List getEntities() throws Exception {
        return this.rssi_recordDAO.getEntities();
    }

    public Rssi getRssiWithLocationAndAP(Location location, AccessPoint ap){

        Session session = HibernateUtil.getSession();
        session.beginTransaction();

        String hql= "from " + Rssi.class.getCanonicalName() + " r where r.location.id = :loc and r.accessPoint.id = :accesspoint";

        Query query = session.createQuery(hql);
        query.setParameter("loc", location.getId());
        query.setParameter("accesspoint",ap.getId());

        Rssi result = (Rssi)query.getSingleResult();

        return result;
    }

    public List<Rssi> getRssiWithMacAdress(String mac){

        Session session = HibernateUtil.getSession();
        session.beginTransaction();

        String hql= "from " + Rssi.class.getCanonicalName() + " r where r.accessPoint.mac_address = :macAddress";

        Query query = session.createQuery(hql);
        query.setParameter("macAddress", mac);

        List<Rssi> result = query.list();

        return result;
    }


}
