package com.lo53_mobile_localization.core.service;

import com.lo53_mobile_localization.core.entity.AccessPoint;
import com.lo53_mobile_localization.core.entity.IEntity;
import com.lo53_mobile_localization.core.repository.AccessPointDAO;
import org.junit.Before;
import org.junit.Test;

import java.util.ArrayList;

import static org.junit.Assert.assertEquals;

/**
 * Created by Thomas on 10/05/2017.
 */
public class AccessPointServiceTest extends BaseServiceTest{

    @Before
    public void setUp() throws Exception {
        super.setUp();
        service = new AccessPointService();

        AccessPoint ap = new AccessPoint();

        ap.setMac_address("00:00:00:00:00:00");
        ap.setLocation_id(genLocation());

        AccessPointDAO accessPointDAO = new AccessPointDAO();
        accessPointDAO.insertEntity(ap);

        item = ap;
    }

    protected ArrayList<IEntity> storeMultipleTestingItems(int nbItems) throws Exception {
        ArrayList<IEntity> aps = new ArrayList<>();

        int startingId = 1;
        for(int i = startingId; i < nbItems + startingId; i++) {
            AccessPoint testingAP = new AccessPoint();
            testingAP.setMac_address("AA:AA:AA:AA:AA:A" + i);
            testingAP.setLocation_id(genLocation());

            service.storeEntity(testingAP);
            aps.add(testingAP);
        }

        return aps;
    }

    @Test
    public void updateEntity() throws Exception {
        AccessPoint ap = (AccessPoint) item;
        ap.setMac_address("ZZ:ZZ:ZZ:ZZ:ZZ:ZZ");
        service.updateEntity(ap.getId(), ap);

        AccessPoint storedClient = (AccessPoint) service.getEntity(ap.getId());
        assertEquals(ap.getMac_address(), storedClient.getMac_address());
    }

    @Test
    public void getSingleAccessPointFromMacAdress(){

        AccessPointService apService = new AccessPointService();

        AccessPoint ap = (AccessPoint)item;
        AccessPoint apTest = apService.getSingleAccessPointFromMacAdress(((AccessPoint) item).getMac_address());

        assertEquals(ap.getMac_address(), apTest.getMac_address());

    }


}
