package com.lo53_mobile_localization.core.service;

import com.lo53_mobile_localization.core.entity.IEntity;
import com.lo53_mobile_localization.core.entity.Location;
import com.lo53_mobile_localization.core.repository.LocationDAO;
import org.junit.Before;
import org.junit.Test;

import java.util.ArrayList;

import static org.junit.Assert.assertEquals;

/**
 * Created by Thomas on 10/05/2017.
 */
public class LocationServiceTest extends BaseServiceTest {

    @Before
    public void setUp() throws Exception {
        super.setUp();
        service = new LocationService();

        Location loc = new Location();
        loc.setMap(genMap());
        loc.setX(7);
        loc.setY(7);

        LocationDAO locationDAO = new LocationDAO();
        locationDAO.insertEntity(loc);

        item = loc;
    }

    protected ArrayList<IEntity> storeMultipleTestingItems(int nbItems) throws Exception {
        ArrayList<IEntity> locs = new ArrayList<>();

        int startingId = 1;
        for(int i = startingId; i < nbItems + startingId; i++) {
            Location testingLoc = new Location();
            testingLoc.setMap(genMap());
            testingLoc.setX(i);
            testingLoc.setY(i);

            service.storeEntity(testingLoc);
            locs.add(testingLoc);
        }

        return locs;
    }

    @SuppressWarnings("deprecation")
    @Test
    public void updateEntity() throws Exception {
        Location loc = (Location) item;
        loc.setY(100);
        service.updateEntity(loc.getId(), loc);

        Location storedClient = (Location) service.getEntity(loc.getId());
        assertEquals((int)loc.getY(), (int)storedClient.getY());
    }
}
