package com.lo53_mobile_localization.core.service;

import com.lo53_mobile_localization.core.entity.IEntity;
import com.lo53_mobile_localization.core.entity.Map;
import com.lo53_mobile_localization.core.repository.MapDAO;
import org.junit.Before;
import org.junit.Test;

import java.util.ArrayList;

import static org.junit.Assert.assertEquals;

/**
 * Created by Thomas on 10/05/2017.
 */
public class MapServiceTest extends BaseServiceTest {

    @Before
    public void setUp() throws Exception {
        super.setUp();
        service = new MapService();

        Map map = new Map();

        MapDAO mapDAO = new MapDAO();
        mapDAO.insertEntity(map);

        item = map;
    }

    protected ArrayList<IEntity> storeMultipleTestingItems(int nbItems) throws Exception {
        ArrayList<IEntity> maps = new ArrayList<>();

        int startingId = 1;
        for(int i = startingId; i < nbItems + startingId; i++) {
            Map testingMap = new Map();
            testingMap.setDescription("Description" + i);
            testingMap.setPx_height(i);
            testingMap.setPx_width(i);
            testingMap.setM_height(i);
            testingMap.setM_width(i);

            service.storeEntity(testingMap);
            maps.add(testingMap);
        }

        return maps;
    }

    @Test
    public void updateEntity() throws Exception {
        Map map = (Map) item;
        map.setM_width(100);
        service.updateEntity(map.getId(), map);

        Map storedClient = (Map) service.getEntity(map.getId());
        assertEquals((int)map.getM_width(), (int)storedClient.getM_width());
    }
}
